Makefile.am 9.68 KB
Newer Older
1 2 3 4 5
# Ganeti makefile
# - Indent with tabs only.
# - Keep files sorted; one line per file.
# - Directories in lib/ must have their own *dir variable (see hypervisor).
# - All directories must be listed DIRS.
Michael Hanselmann's avatar
Michael Hanselmann committed
6
# - Use autogen.sh to generate Makefile.in and configure script.
7 8 9 10 11

# Automake doesn't export these variables before version 1.10.
abs_top_builddir = @abs_top_builddir@
abs_top_srcdir = @abs_top_srcdir@

12
ACLOCAL_AMFLAGS = -I autotools
13 14 15 16
DOCBOOK_WRAPPER = $(top_srcdir)/autotools/docbook-wrapper
REPLACE_VARS_SED = autotools/replace_vars.sed

hypervisordir = $(pkgpythondir)/hypervisor
17
httpdir = $(pkgpythondir)/http
18
rapidir = $(pkgpythondir)/rapi
19 20 21 22 23 24 25 26 27 28
toolsdir = $(pkglibdir)/tools
docdir = $(datadir)/doc/$(PACKAGE)

DIRS = \
	autotools \
	daemons \
	devel \
	doc \
	doc/examples \
	lib \
29
	lib/http \
30
	lib/hypervisor \
31
	lib/rapi \
32 33 34 35 36 37 38
	man \
	qa \
	scripts \
	test \
	test/data \
	tools

Iustin Pop's avatar
Iustin Pop committed
39
MAINTAINERCLEANFILES = \
40
	$(docpng) \
Iustin Pop's avatar
Iustin Pop committed
41 42
	$(maninput)

43 44 45
maintainer-clean-local:
	-rm -rf doc/api doc/build doc/html

46 47 48
CLEANFILES = \
	autotools/replace_vars.sed \
	devel/upload \
49
	doc/examples/bash_completion \
50 51 52
	doc/examples/ganeti.initd \
	doc/examples/ganeti.cron \
	lib/*.py[co] \
53
	lib/http/*.py[co] \
54
	lib/hypervisor/*.py[co] \
55
	lib/rapi/*.py[co] \
Iustin Pop's avatar
Iustin Pop committed
56 57
	$(man_MANS) \
	$(manhtml) \
58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74
	qa/*.py[co] \
	test/*.py[co] \
	stamp-directories \
	$(nodist_pkgpython_PYTHON)

nodist_pkgpython_PYTHON = \
	lib/_autoconf.py

pkgpython_PYTHON = \
	lib/__init__.py \
	lib/backend.py \
	lib/bdev.py \
	lib/bootstrap.py \
	lib/cli.py \
	lib/cmdlib.py \
	lib/config.py \
	lib/constants.py \
75
	lib/daemon.py \
76 77
	lib/errors.py \
	lib/jqueue.py \
78
	lib/jstore.py \
79 80 81 82 83 84 85 86 87
	lib/locking.py \
	lib/luxi.py \
	lib/mcpu.py \
	lib/objects.py \
	lib/opcodes.py \
	lib/rpc.py \
	lib/serializer.py \
	lib/ssconf.py \
	lib/ssh.py \
88 89
	lib/utils.py \
	lib/workerpool.py
90 91 92 93 94

hypervisor_PYTHON = \
	lib/hypervisor/__init__.py \
	lib/hypervisor/hv_base.py \
	lib/hypervisor/hv_fake.py \
Guido Trotter's avatar
Guido Trotter committed
95
	lib/hypervisor/hv_kvm.py \
96 97
	lib/hypervisor/hv_xen.py

98 99
rapi_PYTHON = \
	lib/rapi/__init__.py \
100 101 102
	lib/rapi/baserlib.py \
	lib/rapi/connector.py \
	lib/rapi/rlib2.py
103

104
http_PYTHON = \
105
	lib/http/__init__.py \
106
	lib/http/auth.py \
107 108
	lib/http/client.py \
	lib/http/server.py
109

110

Michael Hanselmann's avatar
Michael Hanselmann committed
111
docrst = \
112
	doc/admin.rst \
113
	doc/design-2.0.rst \
114
	doc/design-2.1.rst \
115
	doc/glossary.rst \
116
	doc/hooks.rst \
117
	doc/iallocator.rst \
118
	doc/index.rst \
119
	doc/install.rst \
120
	doc/rapi.rst \
121
	doc/security.rst
Michael Hanselmann's avatar
Michael Hanselmann committed
122

123 124 125 126 127 128 129 130 131 132
doc/html: $(docrst) $(docpng) doc/conf.py configure.ac
	@test -n "$(SPHINX)" || \
	    { echo 'sphinx-build' not found during configure; exit 1; }
	mkdir -p doc/build/doctrees
	PYTHONPATH=.:$(top_builddir) sphinx-build -q -b html \
	    -d doc/build/doctrees \
	    -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
	    -D release="$(PACKAGE_VERSION)" \
	    $(top_srcdir)/doc doc/html
	touch "$@"
Iustin Pop's avatar
Iustin Pop committed
133

134 135 136
docdot = \
	doc/arch-2.0.dot

137
docpng = $(patsubst %.dot,%.png,$(docdot))
138

139
noinst_DATA = $(manhtml) doc/html
140

141 142 143 144
dist_sbin_SCRIPTS = \
	daemons/ganeti-noded \
	daemons/ganeti-watcher \
	daemons/ganeti-masterd \
145
	daemons/ganeti-rapi \
146 147 148 149 150 151 152 153 154 155 156 157 158 159 160
	scripts/gnt-backup \
	scripts/gnt-cluster \
	scripts/gnt-debug \
	scripts/gnt-instance \
	scripts/gnt-job \
	scripts/gnt-node \
	scripts/gnt-os

dist_tools_SCRIPTS = \
	tools/burnin \
	tools/cfgshell \
	tools/cfgupgrade \
	tools/lvmstrap

EXTRA_DIST = \
Iustin Pop's avatar
Iustin Pop committed
161
	$(MAINTAINERCLEANFILES) \
162 163
	NEWS \
	DEVNOTES \
Michael Hanselmann's avatar
Michael Hanselmann committed
164
	pylintrc \
165 166
	autotools/docbook-wrapper \
	devel/upload.in \
167
	$(docdot) \
168 169 170
	$(docrst) \
	doc/conf.py \
	doc/html \
171
	doc/examples/bash_completion.in \
172 173 174
	doc/examples/ganeti.initd.in \
	doc/examples/ganeti.cron.in \
	doc/examples/dumb-allocator \
175
	doc/locking.txt \
176 177 178 179 180
	test/testutils.py \
	test/mocks.py \
	$(dist_TESTS) \
	$(TEST_FILES) \
	man/footer.sgml \
Iustin Pop's avatar
Iustin Pop committed
181
	$(mansgml) $(maninput) \
182
	qa/ganeti-qa.py \
Michael Hanselmann's avatar
Michael Hanselmann committed
183
	qa/qa-sample.json \
184 185 186 187 188 189 190 191
	qa/qa_cluster.py \
	qa/qa_config.py \
	qa/qa_daemon.py \
	qa/qa_env.py \
	qa/qa_error.py \
	qa/qa_instance.py \
	qa/qa_node.py \
	qa/qa_os.py \
Oleksiy Mishchenko's avatar
Oleksiy Mishchenko committed
192
	qa/qa_rapi.py \
193 194 195 196 197
	qa/qa_tags.py \
	qa/qa_utils.py

man_MANS = \
	man/ganeti.7 \
198
	man/ganeti-masterd.8 \
199 200
	man/ganeti-noded.8 \
	man/ganeti-os-interface.7 \
201
	man/ganeti-rapi.8 \
202 203 204
	man/ganeti-watcher.8 \
	man/gnt-backup.8 \
	man/gnt-cluster.8 \
205
	man/gnt-debug.8 \
206
	man/gnt-instance.8 \
207
	man/gnt-job.8 \
208 209 210
	man/gnt-node.8 \
	man/gnt-os.8

Iustin Pop's avatar
Iustin Pop committed
211 212 213
mansgml = $(patsubst %.7,%.sgml,$(patsubst %.8,%.sgml,$(man_MANS)))
manhtml = $(patsubst %.sgml,%.html,$(mansgml))
maninput = $(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS))) $(patsubst %.html,%.html.in,$(manhtml))
214 215 216

TEST_FILES = \
	test/data/bdev-both.txt \
217
	test/data/bdev-8.3-both.txt \
218 219
	test/data/bdev-disk.txt \
	test/data/bdev-net.txt \
220 221
	test/data/proc_drbd8.txt \
	test/data/proc_drbd83.txt
222 223

dist_TESTS = \
224 225 226
	test/ganeti.bdev_unittest.py \
	test/ganeti.cli_unittest.py \
	test/ganeti.cmdlib_unittest.py \
227
	test/ganeti.config_unittest.py \
228
	test/ganeti.constants_unittest.py \
229
	test/ganeti.hooks_unittest.py \
230
	test/ganeti.http_unittest.py \
231
	test/ganeti.locking_unittest.py \
232
	test/ganeti.rapi.resources_unittest.py \
233 234 235 236
	test/ganeti.serializer_unittest.py \
	test/ganeti.ssh_unittest.py \
	test/ganeti.utils_unittest.py \
	test/ganeti.workerpool_unittest.py
237 238 239 240 241

nodist_TESTS =

TESTS = $(dist_TESTS) $(nodist_TESTS)

242
TESTS_ENVIRONMENT = PYTHONPATH=.:$(top_builddir) $(PYTHON)
243 244

all-local: stamp-directories lib/_autoconf.py devel/upload \
Iustin Pop's avatar
Iustin Pop committed
245
	doc/examples/bash_completion \
246 247 248 249 250 251
	doc/examples/ganeti.initd doc/examples/ganeti.cron

devel/upload: devel/upload.in stamp-directories $(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
	chmod u+x $@

Iustin Pop's avatar
Iustin Pop committed
252
doc/examples/%: doc/examples/%.in stamp-directories \
253 254 255
		$(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@

256
doc/%.png: doc/%.dot
Iustin Pop's avatar
Iustin Pop committed
257
	@test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
258 259
	$(DOT) -Tpng -o $@ $<

Iustin Pop's avatar
Iustin Pop committed
260
man/%.7.in man/%.8.in: man/%.sgml man/footer.sgml $(DOCBOOK_WRAPPER)
261
	@test -n "$(DOCBOOK2MAN)" || { echo 'docbook2html' not found during configure; exit 1; }
Iustin Pop's avatar
Iustin Pop committed
262 263 264 265 266 267 268
	TMPDIR=`mktemp -d` && { \
	$(DOCBOOK_WRAPPER) "$(DOCBOOK2MAN)" $< $$TMPDIR/$(patsubst man/%.in,%,$@) ; \
	mv $$TMPDIR/$(patsubst man/%.in,%,$@) $@ ; \
	rm -rf "$$TMPDIR" ; \
	}

man/%.html.in: man/%.sgml man/footer.sgml $(DOCBOOK_WRAPPER)
269
	@test -n "$(DOCBOOK2HTML)" || { echo 'docbook2html' not found during configure; exit 1; }
Iustin Pop's avatar
Iustin Pop committed
270 271 272 273 274 275 276 277
	TMPDIR=`mktemp -d` && { \
	$(DOCBOOK_WRAPPER) "$(DOCBOOK2HTML) --nochunks" $< $$TMPDIR/$(patsubst man/%.in,%,$@) ; \
	mv $$TMPDIR/$(patsubst man/%.in,%,$@) $@ ; \
	rm -rf "$$TMPDIR" ; \
	}

man/%.7: man/%.7.in stamp-directories $(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
278

Iustin Pop's avatar
Iustin Pop committed
279 280
man/%.8: man/%.8.in stamp-directories $(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
281

Iustin Pop's avatar
Iustin Pop committed
282 283
man/%.html: man/%.html.in stamp-directories $(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
284

285 286
man/footer.sgml $(TESTS): srclinks

287
$(TESTS): ganeti lib/_autoconf.py
288 289 290 291 292

lib/_autoconf.py: Makefile stamp-directories
	set -e; \
	{ echo '# This file is automatically generated, do not edit!'; \
	  echo '#'; \
Iustin Pop's avatar
Iustin Pop committed
293 294 295 296 297 298 299 300 301
	  echo ''; \
	  echo '"""Build-time configuration for Ganeti.'; \
	  echo '';\
	  echo 'This file is autogenerated by the build process.'; \
	  echo 'For any changes you need to re-run ./configure (and'; \
	  echo 'not edit by hand).'; \
	  echo ''; \
	  echo '"""'; \
	  echo ''; \
302 303 304 305 306 307 308 309 310 311 312 313 314 315 316
	  echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
	  echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
	  echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
	  echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
	  echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
	  echo "VERSION_FULL = '$(VERSION_FULL)'"; \
	  echo "LOCALSTATEDIR = '$(localstatedir)'"; \
	  echo "SYSCONFDIR = '$(sysconfdir)'"; \
	  echo "SSH_INITD_SCRIPT = '$(SSH_INITD_SCRIPT)'"; \
	  echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
	  echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
	  echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
	  echo "XEN_INITRD = '$(XEN_INITRD)'"; \
	  echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
	  echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
317
	  echo "KVM_PATH = '$(KVM_PATH)'"; \
Guido Trotter's avatar
Guido Trotter committed
318
	  echo "KVM_MIGRATION_PORT = '$(KVM_MIGRATION_PORT)'"; \
Guido Trotter's avatar
Guido Trotter committed
319
	  echo "SOCAT_PATH = '$(SOCAT_PATH)'"; \
320
	  echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)" ; \
321 322 323 324 325 326 327 328 329 330 331
	} > $@

$(REPLACE_VARS_SED): Makefile stamp-directories
	set -e; \
	{ echo 's#@PREFIX@#$(prefix)#g'; \
	  echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
	  echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
	  echo 's#@SBINDIR@#$(sbindir)#g'; \
	  echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
	  echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
	  echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
332
	  echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
333 334 335 336 337 338 339
	} > $@

# We need to create symlinks because "make distcheck" will not install Python
# files when building.
#.PHONY: srclinks
srclinks: stamp-directories
	set -e; \
340 341
	for i in man/footer.sgml $(pkgpython_PYTHON) $(hypervisor_PYTHON) \
			$(rapi_PYTHON) $(http_PYTHON); do \
342 343 344 345
		if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
			$(LN_S) $(abs_top_srcdir)/$$i $$i; \
		fi; \
	done
346

Michael Hanselmann's avatar
Michael Hanselmann committed
347 348
.PHONY: ganeti
ganeti:
349
	cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
Michael Hanselmann's avatar
Michael Hanselmann committed
350

Iustin Pop's avatar
Iustin Pop committed
351 352 353 354 355 356 357
# a dist hook rule for catching revision control directories
distcheck-hook:
	if find $(top_distdir) | grep -F -e '.svn' -e '.git'; then \
		echo "Found revision control files in final archive" 1>&2 ; \
		exit 1; \
	fi

Iustin Pop's avatar
Iustin Pop committed
358
install-exec-local:
359
	@mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
360 361
	  "$(DESTDIR)${localstatedir}/log/ganeti" \
	  "$(DESTDIR)${localstatedir}/run/ganeti"
362 363 364 365 366

stamp-directories: Makefile
	@mkdir_p@ $(DIRS)
	touch $@

Iustin Pop's avatar
Iustin Pop committed
367 368 369
.PHONY: apidoc
apidoc:
	test -e doc/api || mkdir doc/api
Iustin Pop's avatar
Iustin Pop committed
370
	TMPDIR=`mktemp -d ` && { \
Iustin Pop's avatar
Iustin Pop committed
371 372
		cp -r scripts daemons lib $$TMPDIR && \
		( \
Iustin Pop's avatar
Iustin Pop committed
373
			CDIR=`pwd` && \
Iustin Pop's avatar
Iustin Pop committed
374 375
			cd $$TMPDIR && \
			mv lib ganeti && \
Iustin Pop's avatar
Iustin Pop committed
376
			epydoc -v --conf $$CDIR/epydoc.conf -o $$CDIR/doc/api \
Iustin Pop's avatar
Iustin Pop committed
377 378 379 380
		) ; \
		rm -rf $$TMPDIR ; \
	}

381 382 383 384 385 386 387
.PHONY: TAGS
TAGS:
	rm -f TAGS
	find . -path './lib/*.py' -o -path 'scripts/gnt-*' -o \
	  -path 'daemons/ganeti-*' -o -path 'tools/*' | \
	  etags -

388
# vim: set noet :